import { Name } from '../../name';
import { Colors } from '../type/colors.type';
import { HSL } from '../type/hsl.type';
export declare class Color<Prefix extends string | undefined, Suffix extends string | undefined, AvailableColor extends string = Colors, C extends AvailableColor = AvailableColor> extends Name<AvailableColor, C, Prefix, Suffix> {
    static colorToHex(color: number): string;
    static hexToRgb(hex: string): {
        red: number;
        green: number;
        blue: number;
    } | undefined;
    static hexToHsl(hex: string): HSL | undefined;
    static hslToRgb(hue: number, saturation: number, lightness: number): {
        red: number;
        green: number;
        blue: number;
    };
    static rgbToHex(red: number, green: number, blue: number): string;
    static rgbToHsl(red: number, green: number, blue: number): HSL;
    constructor(color: C, prefix?: Prefix, suffix?: Suffix, availableColor?: AvailableColor[]);
}
